fgetc(3)

NAME
fgetc, getchar, ungetc - FILE get character

LIBRARY
Standard C library (libc, -lc)

SYNOPSIS
#include <stdio.h>

int fgetc(FILE *stream);
int getchar(void);

int ungetc(int c, FILE *stream);

DESCRIPTION
fgetc() reads the next character from stream and returns it as an unsigned char cast to an int, or EOF on end of file or error.

getchar() is equivalent to fgetc(stdin).

ungetc() pushes c back to stream, cast to unsigned char, where it is available for subsequent read operations. Pushed-back characters will be returned in reverse order; only one pushback is guaranteed.

Calls to the functions described here can be mixed with each other and with calls to other input functions from the stdio library for the same input stream.

For nonlocking counterparts, see unlocked_stdio(3).

RETURN VALUE
fgetc() and getchar() return the character read as an unsigned char cast to an int or EOF on end of file or error.

ungetc() returns c on success, or EOF on error.

On error, errno is set to indicate the error.

ERRORS
See read(2).

ATTRIBUTES
For an explanation of the terms used in this section, see attributes(7).
Interface | Attribute | Value
 | Thread safety | MT-Safe

STANDARDS
C11, POSIX.1-2008.

HISTORY
POSIX.1-2001, C89.

NOTES
It is not advisable to mix calls to input functions from the stdio library with low-level calls to read(2) for the file descriptor associated with the input stream; the results will be undefined and very probably not what you want.

SEE ALSO
read(2), write(2), ferror(3), fgetwc(3), fgets(3), fopen(3), fread(3), fseek(3), getline(3), gets(3), getwchar(3), puts(3), scanf(3), ungetwc(3), unlocked_stdio(3), feature_test_macros(7)